Package net.sf.saxon.om

## Class FocusTrackingIterator

- java.lang.Object
- - net.sf.saxon.om.FocusTrackingIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `FocusIterator`, `SequenceIterator`, `GroundedIterator`, `LookaheadIterator`
  Direct Known Subclasses:
    `MultithreadedFocusTrackingIterator`

      public class FocusTrackingIterator
      extends java.lang.Object
      implements FocusIterator, LookaheadIterator, GroundedIterator, LastPositionFinder

  An iterator that maintains the values of position() and current(), as a wrapper over an iterator which does not maintain these values itself.

  Note that when a FocusTrackingIterator is used to wrap a SequenceIterator in order to track the values of position() and current(), it is important to ensure (a) that the SequenceIterator is initially positioned at the start of the sequence, and (b) that all calls on next() to advance the iterator are directed at the FocusTrackingIterator, and not at the wrapped SequenceIterator.

  Since:
    9.6

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FocusTrackingIterator​(SequenceIterator base)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the iterator.
    `Item` | `current()` | Get the current value in the sequence (the one returned by the most recent call on next()).
    `int` | `getLength()` | Get the position of the last item in the sequence.
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `GroundedValue` | `getResidue()` | Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position.
    `int` | `getSiblingPosition​(NodeInfo node, NodeTest nodeTest, int max)` | Get the sibling position of a node: specifically, count how many preceding siblings of a node satisfy the nodetest.
    `SequenceIterator` | `getUnderlyingIterator()` | Get the underlying iterator
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `GroundedValue` | `materialize()` | Return a GroundedValue containing all the items in the sequence returned by this SequenceIterator.
    `Item` | `next()` | Get the next item in the sequence.
    `int` | `position()` | Get the current position.
    `static FocusTrackingIterator` | `track​(SequenceIterator base)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `forEachOrFail`

- - ### Constructor Detail

    - #### FocusTrackingIterator

          public FocusTrackingIterator​(SequenceIterator base)

  - ### Method Detail

    - #### track

          public static FocusTrackingIterator track​(SequenceIterator base)

    - #### getUnderlyingIterator

          public SequenceIterator getUnderlyingIterator()

      Get the underlying iterator
      Returns:
        the iterator underlying this FocusIterator

    - #### next

          public Item next()
                    throws XPathException

      Get the next item in the sequence. This method changes the state of the iterator, in particular it affects the result of subsequent calls of position() and current().
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item
      Since:
        8.4

    - #### current

          public Item current()

      Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.
      Specified by:
        `current` in interface `FocusIterator`
      Returns:
        the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.
      Since:
        8.4

    - #### position

          public int position()

      Get the current position. This will usually be zero before the first call on next(), otherwise it will be the number of times that next() has been called. Once next() has returned null, the preferred action is for subsequent calls on position() to return -1, but not all existing implementations follow this practice. (In particular, the EmptyIterator is stateless, and always returns 0 as the value of position(), whether or not next() has been called.)

      This method does not change the state of the iterator.

      Specified by:
        `position` in interface `FocusIterator`
      Returns:
        the current position, the position of the item returned by the most recent call of next(). This is 1 after next() has been successfully called once, 2 after it has been called twice, and so on. If next() has never been called, the method returns zero. If the end of the sequence has been reached, the value returned will always be <= 0; the preferred value is -1.
      Since:
        8.4

    - #### getLength

          public int getLength()
                        throws XPathException

      Get the position of the last item in the sequence. The method is stateless in its external effect: that is, it does not change the values returned by position(), next(), hasNext(), etc. However, it creates a new base iterator which means that the result of calling getUnderlyingIterator() may change.
      Specified by:
        `getLength` in interface `FocusIterator`
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the position of the last item
      Throws:
        `XPathException` - if a failure occurs reading the sequence

    - #### hasNext

          public boolean hasNext()

      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

      This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.Property.LOOKAHEAD`

      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items in the sequence
      Throws:
        `java.lang.ClassCastException` - if the base iterator does not support lookahead processing

    - #### materialize

          public GroundedValue materialize()
                                    throws XPathException

      Return a GroundedValue containing all the items in the sequence returned by this SequenceIterator. This should be an "in-memory" value, not a Closure.
      Specified by:
        `materialize` in interface `GroundedIterator`
      Specified by:
        `materialize` in interface `SequenceIterator`
      Returns:
        the corresponding Value
      Throws:
        `XPathException` - in the cases of subclasses (such as the iterator over a MemoClosure) which cause evaluation of expressions while materializing the value.
        `java.lang.ClassCastException` - if the iterator does not have the `SequenceIterator.Property.GROUNDED` property.

    - #### getResidue

          public GroundedValue getResidue()
                                   throws XPathException

      Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position. This should be an "in-memory" value, not a Closure.
      Specified by:
        `getResidue` in interface `GroundedIterator`
      Returns:
        the corresponding Value
      Throws:
        `XPathException` - in the cases of subclasses (such as the iterator over a MemoClosure) which cause evaluation of expressions while materializing the value.
        `java.lang.ClassCastException` - if the iterator does not have the `SequenceIterator.Property.GROUNDED` property.

    - #### close

          public void close()

      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `SequenceIterator`
      Since:
        9.1

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.
      Since:
        8.6

    - #### getSiblingPosition

          public int getSiblingPosition​(NodeInfo node,
                                        NodeTest nodeTest,
                                        int max)

      Get the sibling position of a node: specifically, count how many preceding siblings of a node satisfy the nodetest. This method appears here because it can potentially make use of cached information. When an instruction such as `xsl:apply-templates select="*"` (which selects a set of sibling nodes) is used in conjunction with patterns such as `match="*[position() mod 2 = 1]`, then calculation of the position of one node in the sequence of siblings can take advantage of the fact that the position of the immediately preceding sibling is already known.

      This optimization was suggested by the late Sebastian Rahtz, one of Saxon's earliest power users, and it is dedicated to his memory.

      Parameters:
        `node` - the starting node, which is assumed to satisfy the node test
        `nodeTest` - the node test
        `max` - the maximum number of nodes to be counted
      Returns:
        the number of preceding siblings that satisfy the node test, plus one, unless the number exceeds max, in which case return some number greater than or equal to max.